## supercollider 3.5.2

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.8)
project (SuperCollider)

include("SCVersion.txt")
set(PROJECT_VERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}${PROJECT_VERSION_PATCH}")
message(STATUS "SuperCollider Version: ${PROJECT_VERSION}")

include(CTest)
enable_testing()

include (cmake_modules/FinalFile.cmake)

if (NOT CMAKE_BUILD_TYPE)
	message(STATUS "Build type defaulting to \"RelWithDebInfo\"")
	set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif()

if (${CMAKE_SOURCE_DIR} STREQUAL ${CMAKE_BINARY_DIR})
	message(WARNING "WARNING: IN-PLACE BUILDS ARE NOT RECOMMENDED - PLEASE USE A BUILD DIRECTORY")
endif()


set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules
                      ${CMAKE_MODULE_PATH})

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_modules/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

if(APPLE)
	STRING(REGEX REPLACE "^.*MacOSX10.([0-9]+).*$" "\\1" MAC_OSX_SDK_VERSION  "${CMAKE_OSX_SYSROOT}")

	if(CMAKE_OSX_DEPLOYMENT_TARGET)
		if (CMAKE_OSX_DEPLOYMENT_TARGET GREATER 10.4)
			set(HID_UTIL_DIR "HID_Utilities")
		else()
			set(HID_UTIL_DIR "HID_Utilities_10_4")
		endif()
	else()
		if (${MAC_OSX_SDK_VERSION} GREATER 4)
			set(HID_UTIL_DIR "HID_Utilities")
		else()
			set(HID_UTIL_DIR "HID_Utilities_10_4")
		endif()
	endif()
	MESSAGE( STATUS "Using HID Utilities from folder '${HID_UTIL_DIR}'")
endif()

if (CMAKE_SYSTEM_NAME MATCHES "Linux")
	set(LINUX 1)
endif()

#############################################
# Compiler flags etc

if (${CMAKE_COMPILER_IS_GNUCXX})
	exec_program(${CMAKE_CXX_COMPILER} ARGS -dumpversion OUTPUT_VARIABLE _gcc_version)

	add_definitions("-fschedule-insns2" "-fomit-frame-pointer")

	add_definitions("-Wreturn-type")

#	disabled for now: -ffast-math breaks avx intrinsics and -fsigned-zeros/-fno-associative-math are not available in some versions
#	if (${_gcc_version} VERSION_GREATER 4.0.99)
#		add_definitions("-ffast-math -fsigned-zeros -fno-associative-math")
#	endif()

	option(DSO_VISIBILITY "DSO visibility support for gcc" OFF)

	if (DSO_VISIBILITY)
		add_definitions(-fvisibility=hidden)
	endif()

	if(APPLE)
		exec_program(${CMAKE_CXX_COMPILER} ARGS --version OUTPUT_VARIABLE _gcc_version_info)
		if ("${_gcc_version_info}" MATCHES "Apple")
			add_definitions("-fpascal-strings")
		endif()
		add_definitions("-D_REENTRANT")
	elseif(NOT (WIN32 AND NOT CYGWIN))
		add_definitions("-pthread")
	endif()
endif ()

if (${CMAKE_CXX_COMPILER} MATCHES icpc)
	set(CMAKE_COMPILER_IS_INTEL 1)
	add_definitions(-Wno-unknown-pragmas)
	add_definitions(-simd)
endif()

if (${CMAKE_CXX_COMPILER} MATCHES clang)
	option(DSO_VISIBILITY "DSO visibility support for clang" OFF)

	if (DSO_VISIBILITY)
		add_definitions(-fvisibility=hidden)
	endif()

	set(CMAKE_COMPILER_IS_CLANG 1)
endif()

if(APPLE)
	set_property(DIRECTORY
		APPEND
		PROPERTY COMPILE_DEFINITIONS SC_DARWIN)
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	add_definitions("-DSC_LINUX")
	add_definitions(-DSC_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/SuperCollider")
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
	add_definitions("-DSC_FREEBSD")
	add_definitions(-DSC_DATA_DIR="${CMAKE_INSTALL_PREFIX}/share/SuperCollider")
endif()

if(WIN32)
    set_property(DIRECTORY
                 APPEND
                 PROPERTY COMPILE_DEFINITIONS SC_WIN32 NOMINMAX _WIN32_WINNT=0x0500)

    add_definitions(-DWIN32_LEAN_AND_MEAN)

    if(MSVC)
        SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_RELEASE} /MTd")
        SET(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_DEBUG} /MT")
    endif()
endif()


#############################################
# some default libraries

find_package(Pthreads)

if (NOT PTHREADS_FOUND)
    message(SEND_ERROR "cannot find libpthreads")
endif()
include_directories(${PTHREADS_INCLUDE_DIR})

if (MSVC OR MINGW)
    set(MATH_LIBRARY "")
else()
    find_library(MATH_LIBRARY m)
endif()

if(CURL)
	find_package(CURL)
	if(CURL_FOUND)
		add_definitions("-DHAVE_LIBCURL")
		include_directories(${CURL_INCLUDE_DIRS})
	endif()
endif()

#############################################
# Options
option(NOVA_SIMD "Build with nova-simd support." ON)
option(FINAL_BUILD "Build as single source file." OFF)

option(CURL "Build with curl for remote file download." ON)

option(FFT_GREEN "Use internal 'Green' FFT lib rather than FFTW. (Not recommended.)" OFF)

option(SSE "Compile with support for SSE instructions.")
option(SSE41 "Compile with support for SSE4.1 instructions.")
option(SSE42 "Compile with support for SSE4.2 instructions.")


option(INSTALL_HELP "Install help docs and examples along with the software" ON)
option(INSTALL_OLD_HELP "Install old and deprecated help files" ON)
option(SC_DOC_RENDER "Pre-render SCDoc documentation. (For putting online, etc)" OFF)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    option(SUPERNOVA "Build with supernova as optional audio synthesis server" ON)
elseif()
    option(SUPERNOVA "Build with supernova as optional audio synthesis server" OFF)
endif()

option(SN_MEMORY_DEBUGGING "Build supernova for memory debugging (disable memory pools).")
option(SC_MEMORY_DEBUGGING "Build sclang&scsynth for memory debugging (disable memory pools).")
option(GC_SANITYCHECK "Enable sanity checks in the sclang garbage collector.")

option(NO_LIBSNDFILE "Disable soundfile functionality. (Not recommended.)" OFF)

option(NO_AVAHI "Disable Avahi support. (Not recommended.)" OFF)

option(SCLANG_SERVER "Build with internal server." ON)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	option(SC_WII "Build sclang with WII support" ON)
endif()

option(SC_QT "Build SuperCollider with Qt GUI" ON)
if (SC_QT)
  message( STATUS "Compiling with Qt GUI" )
endif (SC_QT)

if(WIN32)
	option(SC_PSYCOLLIDER "Build PsyCollider" ON)
else()
	option(SC_PSYCOLLIDER "Build PsyCollider" OFF)
endif()

if(WIN32)
    option(SC_WIN_DEP_DIRS
        "A list of directories where dependencies will be searched for when packaging.")
endif()

if(CMAKE_COMPILER_IS_GNUCXX)
    option(NATIVE "Optimize binary for this architecture (binaries may not run on other machines, requires gcc-4.3 or higher).")
    option(LTO "Use GCC's link time optimizer' (experimental).")
endif()

option(SC_SYMLINK_CLASSLIB "Place a symlink of SCCLassLibrary instead of copying" OFF)
option(SC_OX "Try to compile with support for C++0x (experimental, mainly related to supernova)" OFF)

#############################################
# some preprocessor flags
if (CMAKE_COMPILER_IS_GNUCXX OR CMAKE_COMPILER_IS_CLANG)
	if (SSE)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse -mfpmath=sse")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse -mfpmath=sse")
	endif()
	if (SSE41)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse4.1")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.1")
	endif()
	if (SSE42)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -msse4.2")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -msse4.2")
	endif()
	if (NATIVE)
		set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -march=native")
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=native")
	endif()

	if (SC_OX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	endif()
endif()

if (CMAKE_COMPILER_IS_INTEL AND NOT WIN32)
	if (SSE42)
		add_definitions(-xSSE4.2)
	elseif (SSE41)
		add_definitions(-xSSE4.1)
	elseif (SSE)
		add_definitions(-mia32)
	endif()
	if (SC_OX)
		set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++0x")
	endif()

	# disable warnings
	add_definitions(-diag-disable 170) # pointer points outside of underlying object ... used heavily in sclang
	add_definitions(-diag-disable 279) # controlling expression is constant

endif()

if (SC_MEMORY_DEBUGGING)
	add_definitions(-DDISABLE_MEMORY_POOLS)
endif()

#############################################
# subdirectories
add_subdirectory(external_libraries)
add_subdirectory(server)
add_subdirectory(lang)
add_subdirectory(bindings)
add_subdirectory(editors)
add_subdirectory(platform)

if(CMAKE_SYSTEM_NAME MATCHES "Linux" OR CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    install(DIRECTORY include/common include/plugin_interface include/server include/lang
        DESTINATION ${CMAKE_INSTALL_PREFIX}/include/SuperCollider
        FILES_MATCHING PATTERN "*.h"
    )
endif()

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (cmake_modules/MacAppFolder.cmake)

	set(auxresourcesdir ${scappauxresourcesdir})

	# Some aux files which go in the app's folder
	install(FILES README.txt ChangeLog COPYING AUTHORS platform/mac/MOVED_STUFF.txt
		DESTINATION ${scappbundlename}
	)
elseif (WIN32)
	set(auxresourcesdir "SuperCollider")
else()
	set(auxresourcesdir "share/SuperCollider")
endif()

set(SCCLASSLIB_EXCLUDE_REGEX "IGNOREME")

if(NOT SC_QT)
	set(SCCLASSLIB_EXCLUDE_REGEX "${SCCLASSLIB_EXCLUDE_REGEX}|QtCollider")
endif()

if(WIN32)
	set(SCCLASSLIB_EXCLUDE_REGEX "${SCCLASSLIB_EXCLUDE_REGEX}|PsycolliderDocument")
endif()


if(APPLE)

	if(SC_SYMLINK_CLASSLIB)

		#if there are folders inside SCCLassLibrary abort cmake.
		file(GLOB classlibraryfolders "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/[^.]*")
		foreach(onedirectory ${classlibraryfolders})
			message( "${onedirectory}" )
			if(NOT IS_SYMLINK "${onedirectory}")
				message(FATAL_ERROR "Symlinking will fail ! SCClassLibrary folder already exists and has directories inside, please delete it first." )
			endif()
		endforeach(onedirectory)

		message(STATUS "Will create symlink of SCClassLibrary to ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary" )
		if(NOT EXISTS "{CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary")
			install( CODE "EXECUTE_PROCESS(COMMAND mkdir ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary)" )
		endif()
		#symlink the folders inside SCCLassLibrary. Check if QtCollider folder should be symlinked or not.
		file(GLOB classlibraryfolders RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}/SCClassLibrary" "SCClassLibrary/[^.]*")
		foreach(onedirectory ${classlibraryfolders})
			if(NOT "${onedirectory}" MATCHES "${SCCLASSLIB_EXCLUDE_REGEX}")
				install( CODE
					"EXECUTE_PROCESS(COMMAND ln -shF ${CMAKE_CURRENT_SOURCE_DIR}/SCClassLibrary/${onedirectory} ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/${onedirectory} )" )
			endif()
		endforeach(onedirectory)
	else()
		message(STATUS "Will copy SCCLassLibrary to ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}")

		#if directory contains symlinks, unlink them.
		if(EXISTS "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary")
			file(GLOB classlibraryfolders "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/SCClassLibrary/[^.]*")
			foreach(onedirectory ${classlibraryfolders})
				if(IS_SYMLINK "${onedirectory}")
					message(STATUS "Unlinking ${onedirectory}")
					install( CODE "EXECUTE_PROCESS(COMMAND unlink ${onedirectory} )" )
				endif()
			endforeach(onedirectory)
		endif()

		install(DIRECTORY SCClassLibrary
			DESTINATION ${auxresourcesdir}
			REGEX ${SCCLASSLIB_EXCLUDE_REGEX} EXCLUDE
		)
	endif()
else()
	install(DIRECTORY SCClassLibrary
		DESTINATION ${auxresourcesdir}
		REGEX ${SCCLASSLIB_EXCLUDE_REGEX} EXCLUDE
		PATTERN "*~" EXCLUDE
		PATTERN "*#" EXCLUDE
	)
endif()

configure_file(platform/SCVersion.sc.in SCVersion/SCVersion.sc)
install(DIRECTORY "${CMAKE_BINARY_DIR}/SCVersion" DESTINATION "${auxresourcesdir}/SCClassLibrary")

install(DIRECTORY sounds
	DESTINATION ${auxresourcesdir}
)

if(APPLE AND ("${standalone}" STREQUAL ""))
	set(exampledir "${scappbundlename}")
else()
	set(exampledir "${auxresourcesdir}")
endif()

install(DIRECTORY examples
	DESTINATION ${exampledir}
	PATTERN "*~" EXCLUDE
	PATTERN "*#" EXCLUDE
)

if(INSTALL_OLD_HELP)
	install(DIRECTORY Help
		DESTINATION ${auxresourcesdir}
	)
endif()

if(INSTALL_HELP)
	if(SC_SYMLINK_CLASSLIB AND APPLE)
		message(STATUS "Will create symlink of HelpSource to ${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/HelpSource")
		if(EXISTS "${CMAKE_INSTALL_PREFIX}/${auxresourcesdir}/HelpSource")

=== external_libraries/CMakeLists.txt ===
if (NOT EXISTS ${CMAKE_CURRENT_SOURCE_DIR}/nova-simd/vec.hpp)
    message(FATAL_ERROR "nova-simd submodule is missing: please run `git submodule init && git submodule update' from the toplevel of your git working tree")
endif()

# boost thread
aux_source_directory(boost/libs/thread/src/ boost_thread_src )

include_directories(boost)

if(WIN32)
	aux_source_directory(boost/libs/thread/src/win32/ boost_thread_platform )
	add_definitions(-DBOOST_THREAD_BUILD_DLL)
elseif(PTHREADS_FOUND)
	aux_source_directory(boost/libs/thread/src/pthread/ boost_thread_platform )
else()
	message(SEND_ERROR "we need to implement boost_thread")
endif()

include_directories(${PTHREADS_INCLUDE_DIR})

if (SUPERNOVA)
	aux_source_directory(boost/libs/program_options/src/ boost_program_options )
	add_library(boost_program_options STATIC ${boost_program_options})

	aux_source_directory(boost/libs/system/src/ boost_system )
	add_library(boost_system STATIC ${boost_system})

	aux_source_directory(boost/libs/filesystem/v3/src boost_filesystem_v3)
	add_library(boost_filesystem STATIC ${boost_filesystem_v2} ${boost_filesystem_v3})


	#oscpack
	add_library(oscpack STATIC "oscpack_build.cpp")

	#tlsf
	add_library(tlsf STATIC "TLSF-2.4.6/src/tlsf.c")
	set_target_properties(tlsf
						PROPERTIES COMPILE_DEFINITIONS TLSF_STATISTIC=1)


	if(LTO)
		set_property(TARGET boost_program_options boost_system boost_filesystem oscpack tlsf
					APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

		set_property(TARGET boost_program_options boost_system boost_filesystem oscpack tlsf
					APPEND PROPERTY LINK_FLAGS "-flto -flto-report")
	endif()
endif()

if (${DSO_VISIBILITY})
	remove_definitions(-fvisibility=hidden)
endif()

add_library(boost_thread STATIC ${boost_thread_src} ${boost_thread_platform})

add_library(supercollider_boost_thread SHARED ${boost_thread_src} ${boost_thread_platform})
target_link_libraries(supercollider_boost_thread ${PTHREADS_LIBRARY})

if(LTO)
	set_property(TARGET boost_thread supercollider_boost_thread
				APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

	set_property(TARGET boost_thread supercollider_boost_thread
				APPEND PROPERTY LINK_FLAGS "-flto -flto-report")
endif()


if(APPLE)
	include (${CMAKE_SOURCE_DIR}/cmake_modules/MacAppFolder.cmake)
	install(TARGETS supercollider_boost_thread
			LIBRARY DESTINATION "${scappauxresourcesdir}/../MacOS"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
elseif(WIN32)
	install(TARGETS supercollider_boost_thread
			DESTINATION "SuperCollider"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	install(TARGETS supercollider_boost_thread
			LIBRARY DESTINATION "lib"
			RUNTIME DESTINATION "bin"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

=== lang/CMakeLists.txt ===
include_directories(${CMAKE_SOURCE_DIR}/include/common
                    ${CMAKE_SOURCE_DIR}/include/lang
                    ${CMAKE_SOURCE_DIR}/include/plugin_interface
                    ${CMAKE_SOURCE_DIR}/include/server
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost_lockfree
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost
                    ${CMAKE_SOURCE_DIR}/external_libraries/threadpool
                    ${CMAKE_SOURCE_DIR}/external_libraries/yaml-cpp-0.3.0/include
                    ${CMAKE_SOURCE_DIR}/external_libraries/TLSF-2.4.6/src
                    LangSource/Bison)

if(APPLE)
	include_directories("LangPrimSource/${HID_UTIL_DIR}")
elseif(CMAKE_SYSTEM_NAME MATCHES "Linux")
	find_package(ALSA)
elseif(WIN32)
	find_package(Portmidi)
endif()

find_package(Readline 5.0)

find_package(Sndfile)

set(sclang_sources
	LangPrimSource/SC_Wii.cpp
	LangPrimSource/PyrSignalPrim.cpp
	LangPrimSource/PyrSched.cpp
	LangPrimSource/PyrPrimitive.cpp
	LangPrimSource/PyrMathPrim.cpp
	LangPrimSource/SC_ComPort.cpp
	LangPrimSource/OSCData.cpp
	LangPrimSource/PyrArchiver.cpp
	LangPrimSource/PyrArrayPrimitives.cpp
	LangPrimSource/PyrBitPrim.cpp
	LangPrimSource/PyrCharPrim.cpp
	LangPrimSource/PyrFilePrim.cpp
	LangPrimSource/PyrListPrim.cpp
	LangPrimSource/PyrPlatformPrim.cpp
	LangPrimSource/PyrStringPrim.cpp
	LangPrimSource/PyrSymbolPrim.cpp
	LangPrimSource/PyrUnixPrim.cpp
	LangSource/AdvancingAllocPool.cpp
	LangSource/ByteCodeArray.cpp
	LangSource/DumpParseNode.cpp
	LangSource/GC.cpp
	LangSource/InitAlloc.cpp
	LangSource/PyrFileUtils.cpp
	LangSource/PyrInterpreter3.cpp
	LangSource/PyrLexer.cpp
	LangSource/PyrMathOps.cpp
	LangSource/PyrMathSupport.cpp
	LangSource/PyrMessage.cpp
	LangSource/PyrObject.cpp
	LangSource/PyrParseNode.cpp
	LangSource/PyrSignal.cpp
	LangSource/PyrSymbolTable.cpp
	LangSource/SC_LanguageClient.cpp
	LangSource/SC_LibraryConfig.cpp
	LangSource/SC_TerminalClient.cpp
	LangSource/Samp.cpp
	LangSource/SimpleStack.cpp
	LangSource/VMGlobals.cpp
	LangSource/dumpByteCodes.cpp

	${CMAKE_SOURCE_DIR}/common/fftlib.c
	${CMAKE_SOURCE_DIR}/common/SC_AllocPool.cpp
	${CMAKE_SOURCE_DIR}/common/SC_DirUtils.cpp
	${CMAKE_SOURCE_DIR}/common/SC_Sem.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StandAloneInfo_Darwin.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringBuffer.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringParser.cpp
	${CMAKE_SOURCE_DIR}/common/scsynthsend.cpp
	${CMAKE_SOURCE_DIR}/common/sc_popen.cpp
)

file(GLOB boost_system_sources ../external_libraries/boost/libs/system/src/*cpp)
file(GLOB boost_fs_sources ../external_libraries/boost/libs/filesystem/v3/src/*cpp)
file(GLOB boost_regex_sources ../external_libraries/boost/libs/regex/src/*cpp)
list(APPEND sclang_sources ${boost_fs_sources} ${boost_system_sources} ${boost_regex_sources})

file(GLOB yaml_sources ../external_libraries/yaml-cpp-0.3.0/src/*cpp)
list(APPEND sclang_sources ${yaml_sources})

if(NOT WIN32)
	list(APPEND sclang_sources LangPrimSource/PyrSerialPrim.cpp)
endif()

if(WIN32)
	list(APPEND sclang_sources ${CMAKE_SOURCE_DIR}/common/SC_Win32Utils.cpp)
endif()

if(WIN32)
	include_directories(../platform/windows/compat_stuff)
	list(APPEND sclang_sources ../platform/windows/compat_stuff/getopt.c)
endif()

set(sclang_parser_source LangSource/Bison/lang11d_tab.cpp)

add_definitions(-DYYSTACK_USE_ALLOCA)

if(UNIX)
	if(APPLE)
		list(APPEND sclang_sources
			LangPrimSource/WiiMote_OSX/wiiremote.c
			LangPrimSource/SC_HID.cpp
			LangPrimSource/${HID_UTIL_DIR}/HID_Utilities.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Name_Lookup.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Queue_Utilities.c
			LangPrimSource/${HID_UTIL_DIR}/HID_Error_Handler.c
			LangPrimSource/SC_CoreMIDI.cpp
			LangPrimSource/SC_CoreAudioPrim.cpp
			LangPrimSource/SC_Speech.M
			)
		add_definitions(-DHAVE_SPEECH)
		if (CMAKE_COMPILER_IS_GNUCXX)
			set_source_files_properties(LangPrimSource/SC_Speech.M
										PROPERTIES COMPILE_FLAGS "-x objective-c++ -fobjc-exceptions")
		endif()
		if(NOT (HID_UTIL_DIR MATCHES "HID_Utilities_10_4"))
			list(APPEND sclang_sources
				LangPrimSource/${HID_UTIL_DIR}/IOHIDElement_.c
				LangPrimSource/${HID_UTIL_DIR}/IOHIDDevice_.c
			)
		endif()
	else(APPLE)
		if(ALSA_FOUND)
			list(APPEND sclang_sources LangPrimSource/SC_AlsaMIDI.cpp)
		endif()
		list(APPEND sclang_sources LangPrimSource/SC_LID.cpp)
		add_definitions(-DHAVE_LID)
	endif(APPLE)
else(UNIX)
endif(UNIX)

if(WIN32)
	include_directories (../platform/windows/compat_stuff)
	list(APPEND sclang_sources ../platform/windows/compat_stuff/getopt.c)
	if(PORTMIDI_FOUND)
		include_directories (${PORTMIDI_INCLUDE_DIRS})
		add_definitions(-DHAVE_PORTMIDI)
		list(APPEND sclang_sources LangPrimSource/SC_PortMidi.cpp)
	endif()
endif()

if (SC_WII OR APPLE)
	if(CMAKE_SYSTEM_NAME MATCHES "Linux")
		find_package(CWiid)
		find_package(Bluetooth)

		if (BLUETOOTH_FOUND AND CWIID_FOUND)
			add_definitions(-DHAVE_WII)
			include_directories(${CWIID_INCLUDE_DIRS} ${BLUETOOTH_INCLUDE_DIRS})
			message(STATUS "Compiling with WiiMote support")
		else()
			message(SEND_ERROR "Cannot find libcwiid or libbluetooth")
		endif()
	elseif(APPLE)
		add_definitions(-DHAVE_WII)
		list(APPEND sclang_sources LangPrimSource/WiiMote_OSX/wiiremote.c)
		include_directories(LangPrimSource/WiiMote_OSX)
	endif()
endif()

include(../SCDoc/CMakeLists.txt)
list(APPEND sclang_sources ${SCDOC_SRCS})


if(SC_QT)
	set(QT_COLLIDER_LANG_CLIENT ON)
	include(../QtCollider/CMakeLists.txt)
	list(APPEND sclang_sources ${QT_COLLIDER_SRCS})
endif()

if(0 AND FINAL_BUILD) # sclang final-builds are broken
	CREATE_FINAL_FILE(libsclang_final.cpp ${sclang_sources})
	add_library(libsclang SHARED libsclang_final.cpp ${sclang_parser_source})
else()
	add_library(libsclang STATIC ${sclang_sources} ${sclang_parser_source})
endif()

set_property(TARGET libsclang
	APPEND
	PROPERTY COMPILE_DEFINITIONS BUILDING_SUPERCOLLIDER)

if (SC_WII OR APPLE)
	if (BLUETOOTH_FOUND AND CWIID_FOUND)
		target_link_libraries(libsclang ${BLUETOOTH_LIBRARIES} ${CWIID_LIBRARIES})
	elseif(APPLE)
		target_link_libraries(libsclang "-framework IOBluetooth")
	endif()
endif()

if (SCLANG_SERVER)
	target_link_libraries(libsclang libscsynth)
else()
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS NO_INTERNAL_SERVER
		)
endif()


set_property(TARGET libsclang
	PROPERTY OUTPUT_NAME sclang)


## external libraries
if(READLINE_FOUND)
	message(STATUS "Compiling with Readline support")
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS HAVE_READLINE)
	include_directories(${READLINE_INCLUDE_DIR})
	target_link_libraries(libsclang ${READLINE_LIBRARY})
endif(READLINE_FOUND)

if (APPLE)
	target_link_libraries(libsclang "-framework Carbon")
	target_link_libraries(libsclang "-framework CoreAudio")
	target_link_libraries(libsclang "-framework CoreMIDI")
	target_link_libraries(libsclang "-framework IOKit")
	target_link_libraries(libsclang "-framework CoreServices")
endif()

if(ALSA_FOUND)
	message(STATUS "Compiling with ALSA midi support")
	set_property(TARGET libsclang
		APPEND
		PROPERTY COMPILE_DEFINITIONS HAVE_ALSA=1)
	target_link_libraries(libsclang ${ALSA_LIBRARY})
endif(ALSA_FOUND)

if(SNDFILE_FOUND)
	include_directories(${SNDFILE_INCLUDE_DIR})
	target_link_libraries(libsclang ${SNDFILE_LIBRARIES})
elseif(NOT NO_LIBSNDFILE)
	message(SEND_ERROR "Cannot find libsndfile")
endif(SNDFILE_FOUND)

if (FFTW3F_FOUND)
	include_directories (${FFTW3F_INCLUDE_DIR})
	target_link_libraries(libsclang ${FFTW3F_LIBRARY})
endif()

if (WIN32)
	target_link_libraries(libsclang wsock32 ws2_32)
	if(PORTMIDI_FOUND)
		target_link_libraries(libsclang ${PORTMIDI_LIBRARIES})
	endif()
endif()

if (GC_SANITYCHECK)
	add_definitions(-DGC_SANITYCHECK)
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	target_link_libraries(libsclang rt)
endif()

target_link_libraries(libsclang ${PTHREADS_LIBRARY} supercollider_boost_thread)

if(SC_QT)
	target_link_libraries(libsclang ${QT_COLLIDER_LIBS})
endif()

add_executable(sclang LangSource/cmdLineFuncs.cpp)
target_link_libraries(sclang libsclang boost_thread)

set_property(TARGET sclang
	APPEND
	PROPERTY COMPILE_DEFINITIONS USE_SC_TERMINAL_CLIENT)

if(LTO)
    set_property(TARGET sclang libsclang
                 APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

    set_property(TARGET sclang libsclang
                 APPEND PROPERTY LINK_FLAGS "-flto -flto-report -fwhole-program")
endif()

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (${CMAKE_SOURCE_DIR}/cmake_modules/MacAppFolder.cmake)

	install(TARGETS sclang
			DESTINATION "${scappauxresourcesdir}"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
elseif(WIN32)
	install(TARGETS sclang
			DESTINATION "SuperCollider"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	install(TARGETS sclang
			LIBRARY DESTINATION "lib"
			RUNTIME DESTINATION "bin"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

=== server/CMakeLists.txt ===
if (NOT APPLE AND NOT WIN32)
	# on apple we leave this undefined so it defaults to .scx (in the code)
	add_definitions("-DSC_PLUGIN_EXT=\".so\"")
endif()


include_directories(${CMAKE_SOURCE_DIR}/external_libraries
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost_lockfree
                    ${CMAKE_SOURCE_DIR}/external_libraries/nova-simd
                    ${CMAKE_SOURCE_DIR}/external_libraries/nova-tt
                    )

add_subdirectory(plugins)
add_subdirectory(scsynth)

if (SUPERNOVA)
  add_subdirectory(supernova)
endif()

=== editors/scvim/CMakeLists.txt ===
install(FILES bin/sclangpipe_app bin/scvim
		DESTINATION bin
		PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)

install(DIRECTORY ftplugin
		DESTINATION share/vim/addons)

install(DIRECTORY indent
		DESTINATION share/vim/addons)

install(DIRECTORY syntax
		DESTINATION share/vim/addons)

configure_file(registry/supercollider-vim.yaml.in registry/supercollider-vim.yaml)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/registry/supercollider-vim.yaml
		DESTINATION share/vim/registry)

IF(${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	install(FILES scclasses/SCVim.sc
			DESTINATION /Library/Application\ Support/SuperCollider/Extensions/scvim
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
ELSE()
	install(FILES scclasses/SCVim.sc
         DESTINATION share/SuperCollider/Extensions/scvim
	 PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
ENDIF()

install(FILES scvimrc SCVim.scd
		DESTINATION share/scvim)

=== server/scsynth/CMakeLists.txt ===
find_package(Sndfile)
if (WIN32)
	find_package(Portaudio)
endif()

# here we choose who provides us with the FFT lib
if (FFT_GREEN)
	add_definitions("-DSC_FFT_GREEN")
elseif (APPLE)
	add_definitions("-DSC_FFT_VDSP")
else()
	find_package(FFTW3f)

	if (FFTW3F_FOUND)
		add_definitions("-DSC_FFT_FFTW")
	else()
		message(SEND_ERROR "Cannot find libfftw3f")
	endif()
endif()


if (NO_AVAHI)

elseif (APPLE)
	add_definitions(-DUSE_RENDEZVOUS=1)
else()
	find_package(Avahi)
	if (AVAHI_FOUND)
		add_definitions(-DUSE_RENDEZVOUS=1)
	endif()
endif()

# Here we work out which audio API to use, from system type and/or user option.
string(TOLOWER "$ENV{AUDIOAPI}" AUDIOAPI)
if(AUDIOAPI STREQUAL "")
	if(APPLE)
		set(AUDIOAPI coreaudio)
	elseif(WIN32)
		set(AUDIOAPI portaudio)
	else()
		set(AUDIOAPI jack)
	endif(APPLE)
endif()

if(NOT AUDIOAPI MATCHES "^(jack|coreaudio|portaudio)$")
	message(WARNING "Unrecognised audio API: ${AUDIOAPI}")
endif()

if(AUDIOAPI STREQUAL jack)
	find_package(Jack)
	if(NOT JACK_FOUND)
		message(FATAL_ERROR "Jack selected as audio API, but development files not found")
	endif()
elseif(AUDIOAPI STREQUAL portaudio)
	find_package(Portaudio)
	if(NOT PORTAUDIO_FOUND)
		message(FATAL_ERROR "Portaudio selected as audio API, but development files not found")
	endif()
endif()
message(STATUS "Audio API: ${AUDIOAPI}")

set(scsynth_sources
	Samp.cpp
	SC_BufGen.cpp
	SC_Carbon.cpp

	SC_ComPort.cpp
	SC_CoreAudio.cpp
	SC_Errors.cpp
	SC_Graph.cpp
	SC_GraphDef.cpp
	SC_Group.cpp
	SC_Lib_Cintf.cpp
	SC_Lib.cpp
	SC_MiscCmds.cpp
	SC_Node.cpp
	SC_Rate.cpp
	SC_SequencedCommand.cpp
	SC_Str4.cpp
	SC_Unit.cpp
	SC_UnitDef.cpp
	SC_World.cpp
	Rendezvous.cpp

	${CMAKE_SOURCE_DIR}/common/SC_fftlib.cpp
	${CMAKE_SOURCE_DIR}/common/SC_AllocPool.cpp
	${CMAKE_SOURCE_DIR}/common/SC_DirUtils.cpp
	${CMAKE_SOURCE_DIR}/common/SC_Sem.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StandAloneInfo_Darwin.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringBuffer.cpp
	${CMAKE_SOURCE_DIR}/common/SC_StringParser.cpp
	${CMAKE_SOURCE_DIR}/common/scsynthsend.cpp
	${CMAKE_SOURCE_DIR}/common/sc_popen.cpp

	${CMAKE_SOURCE_DIR}/external_libraries/TLSF-2.4.6/src/tlsf.c
)

if(WIN32)
    list(APPEND scsynth_sources ${CMAKE_SOURCE_DIR}/common/SC_Win32Utils.cpp)
endif()

if (FFT_GREEN)
	list(APPEND scsynth_sources ../../common/fftlib.c)
endif()

if (FFTW3F_FOUND)
	include_directories (${FFTW3F_INCLUDE_DIR})
endif()


include_directories(${CMAKE_SOURCE_DIR}/include/common
                    ${CMAKE_SOURCE_DIR}/common
                    ${CMAKE_SOURCE_DIR}/include/server
                    ${CMAKE_SOURCE_DIR}/include/plugin_interface)

include_directories (${CMAKE_SOURCE_DIR}/external_libraries/TLSF-2.4.6/src)

set_property(DIRECTORY
             APPEND
             PROPERTY COMPILE_DEFINITIONS SC_MEMORY_ALIGNMENT=32)

if (AUDIOAPI STREQUAL jack)
	list(APPEND scsynth_sources SC_Jack.cpp)
	add_definitions("-DSC_AUDIO_API=SC_AUDIO_API_JACK" ${JACK_DEFINITIONS})
	include_directories(${JACK_INCLUDE_DIRS})
elseif (AUDIOAPI STREQUAL portaudio)
	add_definitions("-DSC_AUDIO_API=SC_AUDIO_API_PORTAUDIO" ${PORTAUDIO_DEFINITIONS})
	include_directories(${PORTAUDIO_INCLUDE_DIRS})
endif()

set (FINAL_BUILD 0) # disable final build for scsynth

if (FINAL_BUILD)
	CREATE_FINAL_FILE(libscsynth_final.cpp ${scsynth_sources})
	add_library(libscsynth SHARED libscsynth_final.cpp)
else()
	add_library(libscsynth SHARED ${scsynth_sources})
endif()

set_property(TARGET libscsynth
	APPEND
	PROPERTY COMPILE_DEFINITIONS BUILDING_SUPERCOLLIDER)

find_library(DL NAMES dl)
if (DL)
    target_link_libraries(libscsynth ${DL})
endif()

if(AVAHI_FOUND)
	add_definitions("-DHAVE_AVAHI=1")
	include_directories(${AVAHI_INCLUDE_DIRS})
	target_link_libraries(libscsynth ${AVAHI_LIBRARIES})
endif()

if(SNDFILE_FOUND)
	include_directories(${SNDFILE_INCLUDE_DIR})
	target_link_libraries(libscsynth ${SNDFILE_LIBRARIES})
elseif(NOT NO_LIBSNDFILE)
	message(SEND_ERROR "Cannot find libsndfile")
endif(SNDFILE_FOUND)

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	add_definitions(-DSC_PLUGIN_DIR="${CMAKE_INSTALL_PREFIX}/lib/SuperCollider/plugins")
endif()

if (AUDIOAPI STREQUAL jack)
	target_link_libraries(libscsynth ${JACK_LIBRARIES})
elseif(AUDIOAPI STREQUAL portaudio)
	target_link_libraries(libscsynth ${PORTAUDIO_LIBRARIES})
elseif(AUDIOAPI STREQUAL coreaudio)
	target_link_libraries(libscsynth "-framework CoreAudio")
endif()

if(PTHREADS_FOUND)
	target_link_libraries(libscsynth ${PTHREADS_LIBRARIES})
endif()


if (WIN32)
	target_link_libraries(libscsynth wsock32 ws2_32 winmm)
endif()


set_property(TARGET libscsynth PROPERTY OUTPUT_NAME scsynth)
# These two properties are ABI version info, not sc version:
set_property(TARGET libscsynth PROPERTY VERSION     1.0.0)
set_property(TARGET libscsynth PROPERTY SOVERSION   1)


if (FFTW3F_FOUND)
	target_link_libraries(libscsynth ${FFTW3F_LIBRARY})
endif()

if (APPLE)
	target_link_libraries(libscsynth "-framework vecLib -framework CoreServices")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
	target_link_libraries(libscsynth rt)
endif()


add_executable(scsynth scsynth_main.cpp)
target_link_libraries(scsynth libscsynth ${PTHREADS_LIBRARY})

if(LTO)
    set_property(TARGET scsynth libscsynth
                 APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

    set_property(TARGET scsynth libscsynth
                 APPEND PROPERTY LINK_FLAGS "-flto -flto-report -fwhole-program")
endif()

#TODO allow apple users to install to fhs-ish path if INSTALL_FHS option is enabled

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (${CMAKE_SOURCE_DIR}/cmake_modules/MacAppFolder.cmake)
	install(TARGETS scsynth libscsynth
			RUNTIME DESTINATION "${scappauxresourcesdir}"
			LIBRARY DESTINATION "${scappauxresourcesdir}/../MacOS"
			PERMISSIONS OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE OWNER_WRITE)
elseif(WIN32)
	install(TARGETS libscsynth scsynth
			DESTINATION "SuperCollider"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
else()
	install(TARGETS libscsynth scsynth
			LIBRARY DESTINATION "lib"
			RUNTIME DESTINATION "bin"
			PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

=== server/supernova/CMakeLists.txt ===
if(NOT APPLE)
    find_package(FFTW3f)

    if (FFTW3F_FOUND)
        add_definitions("-DSC_FFT_FFTW")
        include_directories (${FFTW3F_INCLUDE_DIR})
    else()
        message(SEND_ERROR "Cannot find libfftw3f")
    endif()

endif()

if(CMAKE_COMPILER_IS_GNUCXX)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -ftemplate-depth-4096")
  set(CMAKE_CXX_FLAGS_RELEASE "${CMAKE_CXX_FLAGS_RELEASE} -fomit-frame-pointer")

  if(APPLE)
    if (CMAKE_SIZEOF_VOID_P MATCHES "4")
      # cmpxchg8b is available on all intel apples
      set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -march=i686 -msse -msse2 -mfpmath=sse")
    endif()
  endif()
endif(CMAKE_COMPILER_IS_GNUCXX)

if(MEMORY_DEBUGGING)
    set_property(DIRECTORY .
                 APPEND
                 PROPERTY COMPILE_DEFINITIONS_DEBUG NOVA_MEMORY_DEBUGGING)
endif()



include_directories(${CMAKE_SOURCE_DIR}/external_libraries/boost_endian
                    ${CMAKE_SOURCE_DIR}/external_libraries/boost_move
                    ${CMAKE_SOURCE_DIR}/external_libraries/oscpack
                    ${CMAKE_SOURCE_DIR}/external_libraries/TLSF-2.4.6/src
                    )

if(APPLE)
    include_directories(${CMAKE_SOURCE_DIR}/external_libraries/libsndfile)
endif()

include_directories(${CMAKE_SOURCE_DIR}/include/plugin_interface
                    ${CMAKE_SOURCE_DIR}/include/server
                    ${CMAKE_SOURCE_DIR}/include/common
                    .
                    )

set(libsupernova_src
    sc/sc_synth_prototype.cpp
    sc/sc_osc_handler.cpp
    sc/sc_plugin_interface.cpp
    sc/sc_synth.cpp
    sc/sc_synthdef.cpp
    sc/sc_ugen_factory.cpp
    ../scsynth/Samp.cpp
    ${CMAKE_SOURCE_DIR}/common/SC_fftlib.cpp
    ${CMAKE_SOURCE_DIR}/common/SC_DirUtils.cpp
    ${CMAKE_SOURCE_DIR}/common/SC_StandAloneInfo_Darwin.cpp
    server/buffer_manager.cpp
    server/dsp_context.cpp
    server/memory_pool.cpp
    server/node_graph.cpp
    server/server.cpp
    server/server_args.cpp
)

if(COMPACT_BUILD)
  CREATE_FINAL_FILE(libsupernova_final.cpp ${libsupernova_src})
  add_library (libsupernova STATIC libsupernova_final.cpp)
else()
  add_library (libsupernova STATIC ${libsupernova_src})
endif()

set_property(TARGET libsupernova
             PROPERTY OUTPUT_NAME supernova)

add_executable(supernova server/main.cpp)

set_property(TARGET libsupernova supernova
             APPEND
             PROPERTY COMPILE_DEFINITIONS SUPERNOVA)

find_library(DL NAMES dl)
if (DL)
    set_property(TARGET libsupernova
                 APPEND
                 PROPERTY COMPILE_DEFINITIONS DLOPEN)
    target_link_libraries(libsupernova ${DL})
endif()

if (WIN32 OR APPLE)
    find_package(Portaudio)
    if(NOT PORTAUDIO_FOUND)
        message(FATAL_ERROR "Portaudio missing")
    endif()
    add_definitions(-DPORTAUDIO_BACKEND ${PORTAUDIO_DEFINITIONS})
    include_directories(${PORTAUDIO_INCLUDE_DIRS})
    target_link_libraries(libsupernova ${PORTAUDIO_LIBRARIES})
else()
    find_library(JACK NAMES jack)
    if (JACK)
        set_property(TARGET libsupernova supernova
                    APPEND
                    PROPERTY COMPILE_DEFINITIONS JACK_BACKEND)
        target_link_libraries(libsupernova ${JACK})
        include_directories(${JACK_INCLUDE_DIRS})
    endif()
endif()

find_package(Sndfile)
if (NOT SNDFILE_FOUND)
    message(SEND_ERROR "Cannot find libsndfile")
else()
    target_link_libraries(libsupernova ${SNDFILE_LIBRARIES})
    include_directories(${SNDFILE_INCLUDE_DIR})
endif()

if (FFTW3F_FOUND)
	target_link_libraries(libsupernova ${FFTW3F_LIBRARY})
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    target_link_libraries(libsupernova rt)
endif()

target_link_libraries(libsupernova oscpack tlsf boost_thread boost_system boost_filesystem boost_program_options ${PTHREADS_LIBRARIES})
target_link_libraries(supernova libsupernova)

if(APPLE)
	# determines the app name and app install location (scappbundlename, scappdir):
	include (${CMAKE_SOURCE_DIR}/cmake_modules/MacAppFolder.cmake)

	install(TARGETS supernova
			DESTINATION ${scappauxresourcesdir}
			PERMISSIONS OWNER_READ OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE OWNER_WRITE)
else()

install(TARGETS supernova
        DESTINATION "bin"
        PERMISSIONS OWNER_READ OWNER_WRITE OWNER_EXECUTE GROUP_READ GROUP_EXECUTE WORLD_READ WORLD_EXECUTE)
endif()

if(LTO)
    set_property(TARGET supernova libsupernova
                 APPEND PROPERTY COMPILE_FLAGS "-flto -flto-report")

    set_property(TARGET supernova libsupernova
                 APPEND PROPERTY LINK_FLAGS "-flto -flto-report -fwhole-program")
endif()

if (APPLE)
    target_link_libraries(supernova "-framework vecLib")
    target_link_libraries(supernova "-framework CoreAudio -framework CoreServices")
endif()

=== debian/changelog ===
supercollider (1:3.5.2-1) unstable; urgency=low

  * Imported Upstream version 3.5.2
  * Add manpage for supernova
  * Use system mathjax via dh_linktree
  * Backport fix to vim plugin from upstream

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sat, 16 Jun 2012 10:12:09 -0400

supercollider (1:3.5.1-2) UNRELEASED; urgency=low

  * install supercollider mode for gedit (thanks Tim Blechmann)

 -- Dan Stowell <danstowell@users.sourceforge.net>  Tue, 01 May 2012 10:11:34 +0100

supercollider (1:3.5.1-1) UNRELEASED; urgency=low

  [ Dan Stowell ]
  * Imported Upstream version 3.5.1
  * Import and adapt debian packaging info updates for SC 3.5 from tim blechmann
  * removing scons patches (no longer using scons)
  * Update paths & content of copyright file for SC 3.5

 -- Dan Stowell <danstowell@users.sourceforge.net>  Sat, 07 Apr 2012 14:01:57 +0100

supercollider (1:3.4.5-2) UNRELEASED; urgency=low

  * Drop dpkg-source local-options: Defaults since dpkg-source 1.16.1.
  * Update package relations:
    + Relax to build-depend unversioned on debhelper: needed version
      satisfied even in oldstable.
  * Bump debhelper compat level to 7.
  * Simplify install handling, as supported by debhelper compat level 7.
  * Stop setting bogus (or obsolete?) CDBS_NO_DOC_SYMLINKING.
  * Update copyright file:
    + Merge Files sections with same Licensing and (subsets of) same
      copyright holders.
    + Extend a Files section and drop another, to sync with new upstream
      source.
    + Sort authors by copyright year, and then alphabetically.
    + Add email of original author, from AUTHORS file.
    + Strip excess whitespace, and rewrap License sections at 72 chars.
    + Add Comment field to GNU License sections; shortened, duplicate
      texts dropped, using FSF web address (not postal address), and
      with license strings quoted.
  * Replace README.source:
    + Drop notes on no longer used quilt.
    + Add notes on git-buildpackage and CDBS.
  * Add myself as uploader.
  * Consistently newline-delimit package relations.

 -- Jonas Smedegaard <dr@jones.dk>  Wed, 08 Feb 2012 00:52:02 +0100

=== debian/control ===
Source: supercollider
Section: sound
Priority: optional
Vcs-Git: git://git.debian.org/pkg-multimedia/supercollider.git
Vcs-Browser: http://git.debian.org/?p=pkg-multimedia/supercollider.git;a=summary
Maintainer: Debian Multimedia Packages Maintainers <pkg-multimedia-maintainers@lists.alioth.debian.org>
Uploaders: Alexandre Quessy <alexandre@quessy.net>,
 Dan Stowell <danstowell@users.sourceforge.net>,
 Felipe Sateler <fsateler@debian.org>,
 Jonas Smedegaard <dr@jones.dk>
Build-Depends: cdbs (>= 0.4.73~),
 cmake,
 debhelper,
 dh-linktree,
 libjs-mathjax,
 emacs23 | emacsen,
 libasound2-dev [linux-any],
 libavahi-client-dev,
 libcwiid-dev,
 libfftw3-dev,
 libicu-dev,
 libjack-dev,
 libqt4-dev,
 libqtwebkit-dev,
 libreadline-dev,
 libsndfile1-dev (>= 1.0.16),
 libxt-dev,
 python-all-dev (>= 2.6.6-3~),
 qt4-dev-tools,
 libboost-dev (>= 1.48),
 libboost-date-time-dev (>= 1.48),
 libboost-filesystem-dev (>= 1.48),
 libboost-math-dev (>= 1.48),
 libboost-program-options-dev (>=1.48),
 libboost-regex-dev (>= 1.48),
 libboost-system-dev (>=1.48),
 libboost-thread-dev (>=1.48)
Standards-Version: 3.9.2
Homepage: http://supercollider.sourceforge.net/

Package: supercollider
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends},
 libscsynth1 (= ${binary:Version}),
 supercollider-common (= ${source:Version}),
 supercollider-server (= ${binary:Version}),
Suggests: subversion, rsync
Description: real time audio synthesis programming language
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the language interpreter.

Package: supercollider-common
Architecture: all
Depends: ${misc:Depends}
Breaks: supercollider-server (<< 3.5)
Replaces: supercollider-doc, supercollider-server (<< 3.5)
Description: common files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the architecture independent files for SuperCollider.

Package: supercollider-server
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the synthesis server.

Package: supercollider-supernova
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, jackd
Description: real time audio synthesis server (multiprocessor version)
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the multiprocessor aware synthesis server supernova.

Package: libscsynth1
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: SuperCollider synthesis server library
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the shared library for the synthesis server.

Package: supercollider-dev
Architecture: any
Depends: ${misc:Depends},
 supercollider (= ${binary:Version}),
 libsndfile1-dev (>= 1.0.16)
Conflicts: supercollider-common-dev,
 supercollider-server-dev
Replaces: supercollider-common-dev,
 supercollider-server-dev
Provides: supercollider-common-dev,
 supercollider-server-dev
Description: development files for SuperCollider
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package contains the development files and headers.

Package: supercollider-emacs
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  emacs23 | emacsen
Recommends: w3m-el
Description: SuperCollider mode for Emacs
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Emacs.

Package: supercollider-vim
Architecture: all
Depends: ${misc:Depends},
 supercollider (>= ${source:Version}),
 vim | gvim,
 ruby
Recommends: unhtml | links,
 vim-addon-manager
Suggests: unrtf
Description: SuperCollider mode for Vim
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Vim.


Package: supercollider-gedit
Architecture: all
Depends: ${misc:Depends},
  supercollider (>= ${source:Version}),
  gedit (>=3.0.0)
Description: SuperCollider mode for Gedit
 SuperCollider is an environment and programming language for real time
 audio synthesis and algorithmic composition. It provides an interpreted
 object-oriented language which functions as a network client
 to a state of the art, realtime sound synthesis server.
 .
 This package provides the SuperCollider mode for Gedit.

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/cmake.mk

DEB_DH_INSTALL_SOURCEDIR=debian/tmp

# # Add here any variable or target overrides you need.

DEB_INSTALL_DOCS_supercollider             = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-server      = README_LINUX.txt README.txt
DEB_INSTALL_DOCS_supercollider-emacs       = editors/scel/README
DEB_INSTALL_DOCS_supercollider-vim         = editors/scvim/README editors/scvim/SCVim.scd
DEB_INSTALL_DOCS_supercollider-gedit       = editors/sced/README

DEB_INSTALL_MANPAGES_supercollider-server  = debian/scsynth.1
DEB_INSTALL_MANPAGES_supercollider-supernova = debian/supernova.1
DEB_INSTALL_MANPAGES_supercollider         = debian/sclang.1
DEB_INSTALL_MANPAGES_supercollider-vim     = debian/scvim.1 debian/sclangpipe_app.1

DEB_CMAKE_EXTRA_FLAGS = -DDSO_VISIBILITY=on -DSUPERNOVA=on -DSC_EL_BYTECOMPILE=OFF

binary-fixup/supercollider-common::
	dh_linktree -psupercollider-common

install/supercollider-emacs::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scel.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications

install/supercollider-vim::
	install -d $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
	install -m 644 debian/scvim.desktop $(DEB_DH_INSTALL_SOURCEDIR)/usr/share/applications
